//
window.addEvent('load', function() {
	// add the loaded class to <body> with small delay to avoid low framerate	
	setTimeout(function() {
		document.body.addClass('loaded');
	}, 500);
	// smooth anchor scrolling
	new SmoothScroll({
		'duration': 1000,
		'wheelStops': false
	}); 
	// style area
	if(document.id('gkStyleArea')){
		document.id('gkStyleArea').getElements('a').each(function(element,i){
			element.addEvent('click',function(e){
	            e.stop();
				changeStyle(i+1);
			});
		});
	}
	// font-size switcher
	if(document.id('gkTools') && document.id('gkMainbody')) {
		var current_fs = 100;
		var content_fx = new Fx.Tween(document.id('gkMainbody'), { property: 'font-size', unit: '%', duration: 200 }).set(100);
		document.id('gkToolsInc').addEvent('click', function(e){ 
			e.stop(); 
			if(current_fs < 150) { 
				content_fx.start(current_fs + 10); 
				current_fs += 10; 
			} 
		});
		document.id('gkToolsReset').addEvent('click', function(e){ 
			e.stop(); 
			content_fx.start(100); 
			current_fs = 100; 
		});
		document.id('gkToolsDec').addEvent('click', function(e){ 
			e.stop(); 
			if(current_fs > 70) { 
				content_fx.start(current_fs - 10); 
				current_fs -= 10; 
			} 
		});
	}
	// K2 font-size switcher fix
	if(document.id('fontIncrease') && document.getElement('.itemIntroText')) {
		document.id('fontIncrease').addEvent('click', function() {
			document.getElement('.itemIntroText').set('class', 'itemIntroText largerFontSize');
		});
		
		document.id('fontDecrease').addEvent('click', function() {
			document.getElement('.itemIntroText').set('class', 'itemIntroText smallerFontSize');
		});
	}
	
	// login popup
	if(document.id('gkPopupLogin')) {
		var popup_overlay = document.id('gkPopupOverlay');
		popup_overlay.setStyles({'display': 'block', 'opacity': '0'});
		popup_overlay.fade('out');

		var opened_popup = null;
		var popup_login = null;
		var popup_login_h = null;
		var popup_login_fx = null;

		if(document.id('gkPopupLogin') && document.id('gkLogin')) {
			popup_login = document.id('gkPopupLogin');
			popup_login.setStyle('display', 'block');
			popup_login_h = popup_login.getElement('.gkPopupWrap').getSize().y;
			popup_login_fx = new Fx.Morph(popup_login, {duration:200, transition: Fx.Transitions.Circ.easeInOut}).set({'opacity': 0, 'height': 0 }); 
			document.id('gkLogin').addEvent('click', function(e) {
				new Event(e).stop();
				popup_overlay.fade(0.45);
				popup_login_fx.start({'opacity':1, 'height': popup_login_h});
				opened_popup = 'login';

				(function() {
					if(document.id('modlgn-username')) {
						document.id('modlgn-username').focus();
					}
				}).delay(600);
			});
		}

		popup_overlay.addEvent('click', function() {
			if(opened_popup == 'login')	{
				popup_overlay.fade('out');
				popup_login_fx.start({
					'opacity' : 0,
					'height' : 0
				});
			}
		});
	}
	// scrolling effects - create the lists of elements to animate
	document.getElements('.animate').each(function(element, i) {
		elementsToAnimate.push(['animation', element, element.getPosition().y]);
	});
	
	document.getElements('.animate_queue').each(function(element, i) {
		elementsToAnimate.push(['queue_anim', element, element.getPosition().y]);
	});
});
//
window.addEvent('domready', function() {	
	//
	// some touch devices hacks
	//
	
	// hack modal boxes ;)
	/*document.getElements('a.modal').each(function(link) {
		// register start event
		var lasttouch = [];
		// here
		link.addEvent('touchstart', function() {
			lasttouch = [link, new Date().getTime()];
		});
		// and then
		link.addEvent('touchend', function() {
			// compare if the touch was short ;)
			if(lasttouch[0] == link && Math.abs(lasttouch[1] - new Date().getTime()) < 500) {
				window.location = link.getProperty('href');
			}
		});
	});*/
	// menu movements
	if(document.getElement('.gk-intro')) {
		window.addEvent('scroll', function() {
			var intro = document.getElement('.gkIsWrapperFixed');
			var introh = intro.getSize().y;
			var pos = window.getScroll().y;
			
			if(pos >= 100) {
				document.id('gkTop').setStyle('top', '0px');
			} else if(pos < 100) {
				document.id('gkTop').setStyle('top', '-100px');
			}
			
			if(!Browser.ie8 && pos < introh && window.getSize().x > 1040) {
				intro.getElements('.figcaption').setStyle('top', Math.floor((1.0 * pos) / 8.0) + "px");
			}
		});
	}
	// team overlays
	if(document.getElement('.gkTeam')) {
		var figures = document.getElements('.gkTeam figure');
		
		figures.each(function(figure, i) {
			if(
				figure.getProperty('data-fb') != '' || 
				figure.getProperty('data-twitter') != '' || 
				figure.getProperty('data-gplus') != ''
			) {
				var overlay = new Element('div', {
					'class': 'gkTeamOverlay'
				});
				
				var htmloutput = '';
				var classcounter = 0;
				
				if(figure.getProperty('data-fb') != '') {
					htmloutput += '<a href="'+figure.getProperty('data-fb')+'" data-type="fb">Facebook</a>';
					classcounter++;
				}
				
				if(figure.getProperty('data-twitter') != '') {
					htmloutput += '<a href="'+figure.getProperty('data-twitter')+'" data-type="twitter">Twitter</a>';
					classcounter++;
				}
				
				if(figure.getProperty('data-gplus') != '') {
					htmloutput += '<a href="'+figure.getProperty('data-gplus')+'" data-type="gplus">Google+</a>';
					classcounter++;
				}
				
				overlay.set('html', htmloutput);
				overlay.addClass('gkIcons' + classcounter);
				
				overlay.inject(figure.getElement('img') , 'after');
				
				figure.addEvents({
					'mouseenter': function() { 
						figure.addClass('hover'); 
						var linksAmount = figure.getElements('.gkTeamOverlay a').length;
						for(i = 0; i < linksAmount; i++) {
							gkAddClass(figure.getElement('.gkTeamOverlay').getElements('a')[i], 'active', i);	
						}
					},
					'mouseleave': function() { 
						figure.removeClass('hover'); 
						figure.getElements('.gkTeamOverlay a').removeClass('active');
					}
				});
			}
		});
	}
});
// scroll effects
//
// animations
var elementsToAnimate = [];
// scroll event
window.addEvent('scroll', function() {
	// animate all right sliders
	if(elementsToAnimate.length > 0) {		
		// get the necessary values and positions
		var currentPosition = window.getScroll().y;
		var windowHeight = window.getSize().y;
		// iterate throught the elements to animate
		if(elementsToAnimate.length) {
			for(var i = 0; i < elementsToAnimate.length; i++) {
				if(elementsToAnimate[i][2] < currentPosition + (windowHeight / 1.75)) {
					// create a handle to the element
					var element = elementsToAnimate[i][1];
					// check the animation type
					if(elementsToAnimate[i][0] == 'animation') {
						gkAddClass(element, 'loaded', false);
						// clean the array element
						elementsToAnimate[i] = null;
					}
					// if there is a queue animation
					else if(elementsToAnimate[i][0] == 'queue_anim') {
						element.getElements('.animate_queue_element').each(function(item, j) {
							gkAddClass(item, 'loaded', j);
						});
						// clean the array element
						elementsToAnimate[i] = null;
					}
				}
			}
			// clean the array
			elementsToAnimate = elementsToAnimate.clean();
		}
	}
});
//
function gkAddClass(element, cssclass, i) {
	var delay = element.getProperty('data-delay');
	
	if(!delay) {
		delay = (i !== false) ? i * 150 : 0;
	}

	setTimeout(function() {
		element.addClass(cssclass);
	}, delay);
}
// function to set cookie
function setCookie(c_name, value, expire) {
	var exdate=new Date();
	exdate.setDate(exdate.getDate()+expire);
	document.cookie=c_name+ "=" +escape(value) + ((expire==null) ? "" : ";expires=" + exdate.toUTCString());
}
// Function to change styles
function changeStyle(style){
	var file1 = $GK_TMPL_URL+'/css/style'+style+'.css';
	var file2 = $GK_TMPL_URL+'/css/typography/typography.style'+style+'.css';
	new Asset.css(file1);
	new Asset.css(file2);
	Cookie.write('gk_creativity_j25_style', style, { duration:365, path: '/' });
}